package core;

import jetbrains.buildServer.buildTriggers.BuildTriggerException;
import jetbrains.buildServer.buildTriggers.PolledBuildTrigger;
import jetbrains.buildServer.buildTriggers.PolledTriggerContext;

public class CustomPolledBuildTrigger extends PolledBuildTrigger {

    public CustomPolledBuildTrigger(){
    }

    private String project;

    public String getProject() {
        System.out.println("getting the project name : " + project);
        return project;
    }

    public void setProject(String project) {
        System.out.println("setting the project name : " + project);
        this.project = project;
    }

    /**
     * Checks to see if a pending build exists.  If yes, it will add the build to the queue.
    *  Then we force it to wait 120 seconds to let that build update the started_dt column while
    *  running the preRun nant target.
     */
    @Override
    public void triggerBuild(PolledTriggerContext ptc) throws BuildTriggerException {

        //TODO : Add a description or comment to forced build

        System.out.println(ptc.getTriggerDescriptor().getBuildTriggerService().getName());

        System.out.println(" the project name is " + getProject());
        
        if (DatabaseParser.hasPendingRow(getProject().toLowerCase())) {
            ptc.getBuildType().addToQueue(getProject() + "_Dynamic");

            System.out.println(" ** Forcing TeamCity to wait 120 seconds before checking for another one. ** ");
            //A build was added to the queue. To prevent it from being added again, force a wait.
            //Otherwise, it will kick off again before 'nant clean compileDebug preRun' tasks can run for the project.
                try {
                    Thread.sleep(120000);
                } catch (InterruptedException e) {
                }
        }
    }


}
