package core;

import jetbrains.buildServer.buildTriggers.BuildTriggerDescriptor;
import jetbrains.buildServer.buildTriggers.BuildTriggerService;
import jetbrains.buildServer.buildTriggers.BuildTriggeringPolicy;
import java.util.HashMap;
import org.jetbrains.annotations.NotNull;


public class CustomTrigger extends BuildTriggerService {

    //This file MUST be placed in <Team City install dir>\webapps\ROOT\admin\triggers
    private final String editParametersUrl = "dashboardDetails.jsp";

    private String project;

    public String getProject() {
        return project;
    }

    public void setProject(String project) {
        this.project = project;
    }

    public HashMap getProjectList(){

        HashMap map = new HashMap();
        map.put("Records", "records");
        map.put("IMOS", "imos");
        map.put("Napi", "napi");
        map.put("Screening", "screening");

        return map;
    }

    @Override
    @NotNull
    public String getName() {
        return "MMSCoreTrigger";
    }

    @Override
    @NotNull
    public String getDisplayName() {
        return "MMS Core Dashboard Trigger";
    }

    @Override
    @NotNull
    public String describeTrigger(BuildTriggerDescriptor btd) {
        return "A Custom Trigger to work with the MMS QA Dashboard to queue up dynamic builds.";
    }

    @Override
    @NotNull
    public BuildTriggeringPolicy getBuildTriggeringPolicy() {

        CustomPolledBuildTrigger tt = new CustomPolledBuildTrigger();
        tt.setProject(getProject());
        return (BuildTriggeringPolicy) tt;
    }

    @Override
    public boolean isMultipleTriggersPerBuildTypeAllowed(){
        return true;
    }

    @Override
    public String getEditParametersUrl(){
        //This is mandatory if you want the web UI to show in the select/edit Trigger Details popup modal.
        return editParametersUrl;
    }
}
